import { IContentRow } from "../content";
import { ContentsModel } from "../model";
import { TreeFinderBreadcrumbsElement } from "./breadcrumbs";
import { TreeFinderFiltersElement } from "./filters";
import { TreeFinderGridElement } from "./grid";
export declare class TreeFinderPanelElement<T extends IContentRow> extends HTMLElement {
    connectedCallback(): void;
    clear(): void;
    init({ root, options, modelOptions, gridOptions }: {
        root: T;
        options?: TreeFinderPanelElement.IOptions<T>;
        modelOptions?: ContentsModel.IOptions<T>;
        gridOptions?: TreeFinderGridElement.IOptions<T>;
    }): Promise<void>;
    draw(): Promise<void>;
    create_shadow_dom(): void;
    get model(): ContentsModel<T>;
    get options(): TreeFinderPanelElement.IOptions<T>;
    set options({ showFilter, }: TreeFinderPanelElement.IOptions<T>);
    protected shadowSheet: StyleSheet;
    protected breadcrumbsContainer: HTMLElement;
    protected filterContainer: HTMLElement;
    protected gridContainer: HTMLElement;
    protected breadcrumbs: TreeFinderBreadcrumbsElement<T>;
    protected filters: TreeFinderFiltersElement<T>;
    protected grid: TreeFinderGridElement<T>;
    protected _options: TreeFinderPanelElement.IOptions<T>;
    protected _model: ContentsModel<T>;
    private _initialized;
}
export declare namespace TreeFinderPanelElement {
    interface IOptions<T extends IContentRow> {
        /**
         * if true, add filter inputs in a separate widget above the tree-finder-grid
         */
        showFilter?: boolean;
    }
}
//# sourceMappingURL=panel.d.ts.map