import { Subject } from "rxjs";
import { IContentRow } from "../content";
import { ContentsModel } from "./model";
export declare class ClipboardModel implements ClipboardModel.IClipboardModel {
    /**
     * low-level ccp support functions
     */
    copy<T extends IContentRow>(memo: T[]): void;
    cut<T extends IContentRow>(memo: T[]): void;
    delete<T extends IContentRow>(memo: T[]): void;
    paste<T extends IContentRow>(destination: T): void;
    /**
     * sugar for ccp from selection. contentsModel is left as a free variable
     * to facilitate copying from one contentsModel to another
     */
    copySelection<T extends IContentRow>(contentsModel: ContentsModel<T>): void;
    cutSelection<T extends IContentRow>(contentsModel: ContentsModel<T>): void;
    deleteSelection<T extends IContentRow>(contentsModel: ContentsModel<T>): void;
    pasteSelection<T extends IContentRow>(contentsModel: ContentsModel<T>): void;
    readonly copySub: Subject<IContentRow[]>;
    readonly cutSub: Subject<IContentRow[]>;
    readonly deleteSub: Subject<IContentRow[]>;
    readonly pasteSub: Subject<ClipboardModel.IPaste>;
    protected doCut: boolean;
    protected memo: IContentRow[];
}
export declare namespace ClipboardModel {
    interface IClipboardModel {
        copy<T extends IContentRow>(memo: T[]): void;
        cut<T extends IContentRow>(memo: T[]): void;
        delete<T extends IContentRow>(memo: T[]): void;
        paste<T extends IContentRow>(destination: T): void;
        readonly copySub: Subject<IContentRow[]>;
        readonly cutSub: Subject<IContentRow[]>;
        readonly deleteSub: Subject<IContentRow[]>;
        readonly pasteSub: Subject<IPaste>;
    }
    interface IPaste {
        destination: IContentRow;
        doCut: boolean;
        memo: IContentRow[];
    }
}
//# sourceMappingURL=clipboard.d.ts.map